oyFilterPlug_s Struct Reference
Description: C source code API documentation for the Oyranos project.
Keywords: Oyranos,Color Management,Color Management,ICC,CMS,C,doxygen,API,documentation

| Oyranos Color Management System API - Version 0.9.6

Public Member Functions | Data Fields
oyFilterPlug_s Struct Reference
Conversion

A filter connection structure. More...

`#include <oyFilterPlug_s.h>`

Inheritance diagram for oyFilterPlug_s:
Collaboration diagram for oyFilterPlug_s:

## Public Member Functions
OYAPI oyFilterPlug_s *OYEXPORT | oyFilterPlug_New (oyObject_s object)
| allocate a new FilterPlug object More...
| oyFilterPlug_Copy
| Copy or Reference a FilterPlug object. More...
OYAPI int OYEXPORT | oyFilterPlug_Release (oyFilterPlug_s **filterplug)
| release and possibly deallocate a oyFilterPlug_s object More...
OYAPI int OYEXPORT | oyFilterPlug_Callback (oyFilterPlug_s *c, oyCONNECTOR_EVENT_e e)
| Tell about a oyConversion_s event. More...
OYAPI int OYEXPORT | oyFilterPlug_ConnectIntoSocket (oyFilterPlug_s **p, oyFilterSocket_s **s)
| Connect a oyFilterPlug_s with a oyFilterSocket_s. More...
OYAPI oyFilterNode_s *OYEXPORT | oyFilterPlug_GetNode (oyFilterPlug_s *plug)
| Access oyFilterPlug_s::node. More...
OYAPI oyFilterNode_s *OYEXPORT | oyFilterPlug_GetRemoteNode (oyFilterPlug_s *plug)
| Access oyFilterPlug_s::remote_socket::node. More...
OYAPI oyFilterSocket_s *OYEXPORT | oyFilterPlug_GetSocket (oyFilterPlug_s *plug)
| Access oyFilterPlug_s::remote_socket_. More...
OYAPI oyConnector_s *OYEXPORT | oyFilterPlug_GetPattern (oyFilterPlug_s *plug)
| Access oyFilterPlug_s::pattern. More...
OYAPI const char *OYEXPORT | oyFilterPlug_GetRelatives (oyFilterPlug_s *plug)
| get short description of belonging filter More...
OYAPI oyConnector_s *OYEXPORT | oyFilterSocket_GetPattern (oyFilterSocket_s *socket)
| Access oyFilterPlug_s::pattern. More...
OYAPI oyImage_s *OYEXPORT | oyFilterPlug_ResolveImage (oyFilterPlug_s *plug, oyFilterSocket_s *socket, oyPixelAccess_s *ticket)
| Resolve processing data during a filter run. More...
Public Member Functions inherited from oyStruct_s
const char * | oyStruct_GetTextFromModule (oyStruct_s *obj, oyNAME_e name_type, uint32_t flags)
| get object infos from a module More...
const char * | oyStruct_GetText (oyStruct_s *obj, oyNAME_e name_type, uint32_t flags)
| Get a text dump. More...
| oyStruct_RegisterStaticMessageFunc
| register a function for verbosity More...
| oyStruct_GetInfo
| get a additional string from a object More...
const char * | oyStructTypeToText (oyOBJECT_e type)
| Objects type to small string. More...

## Data Fields
const oyOBJECT_e | type_
| Type of object. More...
oyStruct_Copy_f | copy
| Copy function. More...
oyStruct_Release_f | release
| Release function. More...
oyObject_s | oy_
| Oyranos internal object. More...
Data Fields inherited from oyStruct_s
const oyOBJECT_e | type_
| Type of object. More...
oyStruct_Copy_f | copy
| Copy function. More...
oyStruct_Release_f | release
| Release function. More...
oyObject_s | oy_
| Oyranos internal object. More...

## Detailed Description

A filter connection structure.

The active input version of a oyConnector_s. Each plug can connect to exact one socket.

Version
  Oyranos: 0.1.8

Since
  2008/07/29 (Oyranos: 0.1.8)

Date
  2008/07/29

Examples:
  oyranos_cmm_oJPG.c.

## Member Function Documentation

## ◆ oyFilterPlug_Callback()

OYAPI int OYEXPORT oyFilterPlug_Callback | ( | oyFilterPlug_s * | c,
|  | oyCONNECTOR_EVENT_e | e
| ) |  |

Tell about a oyConversion_s event.

Function oyFilterPlug_Callback

Parameters

  [in,out] | c | the connector
  | e | the event type

Version
  Oyranos: 0.1.8

Since
  2008/07/28 (Oyranos: 0.1.8)

Date
  2008/07/28

References oy_, and oyObject_GetId().

## ◆ oyFilterPlug_ConnectIntoSocket()

OYAPI int OYEXPORT oyFilterPlug_ConnectIntoSocket | ( | oyFilterPlug_s ** | p,
|  | oyFilterSocket_s ** | s
| ) |  |

Connect a oyFilterPlug_s with a oyFilterSocket_s.

Function oyFilterPlug_ConnectIntoSocket

Version
  Oyranos: 0.1.8

Since
  2008/07/30 (Oyranos: 0.1.8)

Date
  2008/07/31

References oyCONNECTOR_EVENT_RELEASED, oyFilterPlugs_s::oyFilterPlugs_MoveIn(), oyFilterPlugs_s::oyFilterPlugs_New(), oyFilterSocket_s::oyFilterSocket_Callback(), oyFilterSocket_s::oyFilterSocket_Release(), oyObject_GetId(), and oyStruct_s::oyStructTypeToText().

## ◆ oyFilterPlug_Copy()

oyFilterPlug_Copy

Copy or Reference a FilterPlug object.

The function is for copying and for referencing. The reference is the most often used way, which saves resourcs and time.

Parameters

  [in] | filterplug | FilterPlug struct object
  | object | NULL - means reference, the optional object triggers a real copy

Referenced by oyFilterNode_s::oyFilterNode_GetPlug().

## ◆ oyFilterPlug_GetNode()

OYAPI oyFilterNode_s *OYEXPORT oyFilterPlug_GetNode | ( | oyFilterPlug_s * | plug | ) |

Access oyFilterPlug_s::node.

Function oyFilterPlug_GetNode

Parameters

  [in] | plug | the plug

Returns
  the node

Version
  Oyranos: 0.5.0

Since
  2012/09/05 (Oyranos: 0.5.0)

Date
  2012/09/05

References oyFilterNode_s::oyFilterNode_Copy(), and oyOBJECT_FILTER_PLUG_S.

## ◆ oyFilterPlug_GetPattern()

OYAPI oyConnector_s *OYEXPORT oyFilterPlug_GetPattern | ( | oyFilterPlug_s * | plug | ) |

Access oyFilterPlug_s::pattern.

Function oyFilterPlug_GetPattern

Parameters

  [in] | plug | the plug

Returns
  capabilities pattern for this filter plug

Version
  Oyranos: 0.5.0

Since
  2012/09/05 (Oyranos: 0.5.0)

Date
  2012/09/05

References oyConnector_s::oyConnector_Copy(), and oyOBJECT_FILTER_PLUG_S.

## ◆ oyFilterPlug_GetRelatives()

OYAPI const char *OYEXPORT oyFilterPlug_GetRelatives | ( | oyFilterPlug_s * | plug | ) |

get short description of belonging filter

Function oyFilterPlug_GetRelatives

Parameters

  [in] | plug | the plug

Returns
  short text

Version
  Oyranos: 0.5.0

Since
  2012/09/05 (Oyranos: 0.5.0)

Date
  2012/09/05

References oyOBJECT_FILTER_PLUG_S.

## ◆ oyFilterPlug_GetRemoteNode()

OYAPI oyFilterNode_s *OYEXPORT oyFilterPlug_GetRemoteNode | ( | oyFilterPlug_s * | plug | ) |

Access oyFilterPlug_s::remote_socket::node.

Function oyFilterPlug_GetRemoteNode

Parameters

  [in] | plug | the plug

Returns
  the remote node

Version
  Oyranos: 0.5.0

Date
  2012/09/24

Since
  2012/09/24 (Oyranos: 0.5.0)

References oyFilterSocket_s::oyFilterSocket_GetNode(), and oyOBJECT_FILTER_PLUG_S.

## ◆ oyFilterPlug_GetSocket()

OYAPI oyFilterSocket_s *OYEXPORT oyFilterPlug_GetSocket | ( | oyFilterPlug_s * | plug | ) |

Access oyFilterPlug_s::remote_socket_.

Function oyFilterPlug_GetSocket

Parameters

  [in] | plug | the plug

Returns
  the remote socket

Version
  Oyranos: 0.5.0

Since
  2012/09/05 (Oyranos: 0.5.0)

Date
  2012/09/05

Examples:
  oyranos_cmm_oJPG.c.

References oyFilterSocket_s::oyFilterSocket_Copy(), and oyOBJECT_FILTER_PLUG_S.

## ◆ oyFilterPlug_New()

OYAPI oyFilterPlug_s *OYEXPORT oyFilterPlug_New | ( | oyObject_s | object | ) |

allocate a new FilterPlug object

Function oyFilterPlug_New

References oyOBJECT_OBJECT_S.

Referenced by oyFilterNode_s::oyFilterNode_GetPlug().

## ◆ oyFilterPlug_Release()

OYAPI int OYEXPORT oyFilterPlug_Release | ( | oyFilterPlug_s ** | filterplug | ) |

release and possibly deallocate a oyFilterPlug_s object

Function oyFilterPlug_Release

Parameters

  [in,out] | filterplug | FilterPlug struct object

References oyOBJECT_FILTER_PLUG_S.

Referenced by oyConversion_s::oyConversion_GetOnePixel(), and oyFilterNode_s::oyFilterNode_GetSocketNode().

## ◆ oyFilterPlug_ResolveImage()

OYAPI oyImage_s *OYEXPORT oyFilterPlug_ResolveImage | ( | oyFilterPlug_s * | plug,
|  | oyFilterSocket_s * | socket,
|  | oyPixelAccess_s * | ticket
| ) |  |

Resolve processing data during a filter run.

Function oyFilterPlug_ResolveImage

The function is a convenience function to use inside a filters oyCMMFilterPlug_Run_f call. The function makes only sense for non root filters.

Parameters

  [in,out] | plug | the filters own plug
  [in,out] | socket | the filters own socket
  [in,out] | ticket | the actual ticket

Returns
  the input image

Version
  Oyranos: 0.1.10

Since
  2009/05/01 (Oyranos: 0.1.10)

Date
  2009/05/01

## ◆ oyFilterSocket_GetPattern()

OYAPI oyConnector_s *OYEXPORT oyFilterSocket_GetPattern | ( | oyFilterSocket_s * | socket | ) |

Access oyFilterPlug_s::pattern.

Function oyFilterPlug_GetPattern

Parameters

  [in] | socket | the socket

Returns
  capabilities pattern for this filter socket

Version
  Oyranos: 0.5.0

Since
  2012/09/05 (Oyranos: 0.5.0)

Date
  2012/09/05

References oyConnector_s::oyConnector_Copy(), and oyOBJECT_FILTER_SOCKET_S.

## Field Documentation

## ◆ copy

oyStruct_Copy_f oyFilterPlug_s::copy

Copy function.

## ◆ oy_

oyObject_s oyFilterPlug_s::oy_

Oyranos internal object.

Features name and hash. Do not change during object life time.

Referenced by oyFilterPlug_Callback().

## ◆ release

oyStruct_Release_f oyFilterPlug_s::release

Release function.

## ◆ type_

const oyOBJECT_e oyFilterPlug_s::type_

Type of object.

The struct type tells Oyranos how to interprete hidden fields.

Examples:
  oyranos_cmm_oJPG.c.

Referenced by oyFilterPlugs_s::oyFilterPlugs_MoveIn().